This service will be undergoing maintenance at 00:00 UTC, 2016-09-28. It is expected to last about 1 hours
Bug 130024 - setsysfont run is too late in rc.sysinit
setsysfont run is too late in rc.sysinit
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: initscripts (Show other bugs)
2
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Bill Nottingham
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2004-08-16 12:53 EDT by Vladimir Kolpakov
Modified: 2014-03-16 22:47 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2005-04-26 14:15:10 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
Fix for console fonts load in rc.sysinit (950 bytes, patch)
2004-08-16 12:58 EDT, Vladimir Kolpakov
no flags Details | Diff
linux console (kbd) files for koi8-lv and uni-511-14-ilya (38.17 KB, application/octet-stream)
2004-08-16 23:52 EDT, Vladimir Kolpakov
no flags Details

  None (edit)
Description Vladimir Kolpakov 2004-08-16 12:53:32 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.7.2)
Gecko/20040803

Description of problem:
Console fonts gets not inherited from boot console on vt-s,
because /sbin/setsysfont is called after opening /dev/tty*.



Version-Release number of selected component (if applicable):
initscripts-7.55.1-1

How reproducible:
Always

Steps to Reproduce:
1. Assign some fancy font in /etc/sysconfig/i18n, for example 
  SYSFONT="latarcyrheb-sun16"
2. Boot system
3. Compare results of showconsolefont on /dev/tty1 and /dev/tty2
  

Additional info:

Fix: 
move the call of /sbin/setsysfont one step earlier in rc.sysinit.
Comment 1 Vladimir Kolpakov 2004-08-16 12:58:34 EDT
Created attachment 102766 [details]
Fix for console fonts load in rc.sysinit
Comment 2 Bill Nottingham 2004-08-16 14:40:17 EDT
Actually, you need to *open* the ttys before loading the font,
otherwise it won't get set correctly either.
Comment 3 Vladimir Kolpakov 2004-08-16 15:04:42 EDT
Bill, --

> Actually, you need to *open* the ttys before loading the font,
> otherwise it won't get set correctly either.

I would agree with this statement if we're talking about
loading font to certain vt.
However, as far as I know,
linux kernel console screen driver _clones_
terminal definition from tty0 when it creates new vt.
Thus newly open vt will inherit setup of the tty0
at the point of opening.

And second, 
please try patch I've attached, -- it works for me.
Thanks,
--w
Comment 4 Bill Nottingham 2004-08-16 15:10:49 EDT
The problem we noticed in testing is that it would clone it
incompletely; notably, the unicode mapping would get screwed up - this
is what was fixed by loading the font after it was created.

Will run some tests.
Comment 5 Bill Nottingham 2004-08-16 15:12:50 EDT
Oddly, on a devel system, showconsolefont never prints anything.
Comment 6 Vladimir Kolpakov 2004-08-16 16:54:58 EDT
I didn test unicode, hope do it tomorrow.

Try
  echo -en '\033%G'
for unicode, or
  echo -en '\033(K\033)K'
for 1-byte charsets.



Comment 7 Vladimir Kolpakov 2004-08-16 23:44:26 EDT
Bill, --

Tested with unicode on FC2, 
seems working as expected with uni-511-14 font
by Ilya Ketris.
Please look uni-511-14.png in attaching fedora-console.tgz, --
there are collected koi (8bit) and unicode setups both.
I didn't found (explicit) '\033%G' anywhere in /etc/profile.d/,
however can't be 100% sure about side effects of other utilities.

Please let me know if you get different result.

BTW, is there any intention to study the kbd package
do look into /etc/sysconfig/console/ also?
We're still using this add-ones for years b/c linux distros 
have different "must have" parts that non-GUI guys
used at most.

Thanks,
--w
Comment 8 Vladimir Kolpakov 2004-08-16 23:52:52 EDT
Created attachment 102778 [details]
linux console (kbd) files for koi8-lv and uni-511-14-ilya 

linux console (kbd) 14-pixels fonts and keymaps
uni-511-14 (from Ilya Ketris)
ruslw (aka "latvian koi8") from Ilya Ketris and Vladimir Kolpakov
Comment 9 Bill Nottingham 2004-08-17 00:24:40 EDT
Not sure I understand your last comment (BTW,...)

The echo is in unicode_start.
Comment 10 Vladimir Kolpakov 2004-08-17 00:49:26 EDT
> The echo is in unicode_start

Thanks.
 
> Not sure I understand your last comment (BTW,...)
w> look into /etc/sysconfig/console/ also?

consider copy to /etc/sysconfig/console/*
default fonts and keymaps (local extensions, or
extracts from /lib/kbd/*, made by configuring tools).
It make sense to keep copies there, rather then in /usr/local/
or as /etc/alternatives/ links,
to resolve chicken-eggs problem with basic console stuff.

Comment 11 Bill Nottingham 2004-08-17 01:42:01 EDT
I believe the /etc/sysconfig/console is only used for keymaps at the
moment.
Comment 12 Vladimir Kolpakov 2004-08-17 02:35:39 EDT
In redhat kbd package setup, -- yes.
In console-tools package, /bin/consolechars is checking

/etc/sysconfig/console/consolefonts/
/etc/sysconfig/console/consoletrans/
/etc/sysconfig/console/keymaps/**/
/etc/sysconfig/console/videomodes/
/usr/lib/kbd/consolefonts/
/usr/lib/kbd/consoletrans/
/usr/lib/kbd/keymaps/**/
/usr/lib/kbd/videomodes/


Comment 13 Matthew Miller 2005-04-26 12:31:24 EDT
Fedora Core 2 is now maintained by the Fedora Legacy project for
security updates only. If this problem is a security issue, please
reopen and reassign to the Fedora Legacy product. If it is not a
security issue and hasn't been resolved in the current FC3 updates or
in the FC4 test release, reopen and change the version to match.
Comment 14 Bill Nottingham 2005-04-26 14:15:10 EDT
http://lkml.org/lkml/2005/4/14/127

is probably the cause of what you're seeing. Won't be backported to FC2, though.

Note You need to log in before you can comment on or make changes to this bug.